#Module-Specific definitions
%define mod_version 0.9.0
%define mod_name mod_dav_repos
%define mod_conf 79_%{mod_name}.conf
%define mod_so %{mod_name}.so
%define sourcename catacomb-%{mod_version}

%define apache_version 2.0.54

# Standard Module Definitions
%define name apache-%{mod_name}
%define version %{apache_version}_%{mod_version}

Summary:	Mod_dav_repos is a DSO module for the apache Web server
Name:		%{name}
Version:	%{version}
Release:	%mkrel 1
Group:		System/Servers
License:	BSD-like
URL:		http://www.webdav.org/catacomb/
Source0:	%{sourcename}.tar.bz2
Source1:	%{mod_conf}.bz2
# wget -rm http://www.webdav.org/catacomb/catacomb_HOWTO.html
Source2:	catacomb_HOWTO.html.bz2
Patch0:		catacomb-0.8.0-compilefixer.patch.bz2
Patch1:		catacomb-0.9.0-version.diff.bz2
Patch2:		catacomb-0.9.0-gcc4.patch.bz2
Requires(pre): rpm-helper
Requires(postun): rpm-helper
Requires(pre):	apache-conf >= 2.0.54
Requires(pre):	apache >= %{apache_version}
Requires:	apache-conf >= 2.0.54
Requires:	apache >= %{apache_version}
Requires:	apache-mod_dav
BuildRequires:	MySQL-devel
BuildRequires:	apache-devel >= %{apache_version}
BuildRequires:	file
Provides:	apache2-mod_dav_repos
Obsoletes:	apache2-mod_dav_repos
BuildRoot:	%{_tmppath}/%{name}-buildroot

%description
Catacomb is a WebDAV repository module for use with the Apache
WebDAV module, mod_dav. Apache mod_dav parses WebDAV and DeltaV
protocol requests into operations on a repository providing
persistent storage of resources and their properties. The default
repository for mod_dav is provided by a separate module,
mod_dav_fs, which stores resource bodies as files in the
filesystem, and stores properties in a (G)DBM database. 

Catacomb provides a replacement for mod_dav_fs called
mod_dav_repos that stores resources and their properties in a
relational database (MySQL). The primary advantage of this
approach is the searching capabilities of the database are used to
implement the DASL protocol. Additionally, the database allows
straightforward implementation of the versioning capabilities of
the DeltaV protocol.

By shifting to relational database technology, Catacomb is a
platform that contains important aspects of typical document
management systems: the ability to store large numbers of
documents, and search over their metadata. Furthermore, it is
possible (via source code modification) to change the set of
predefined properties stored in the main schema of the relational
database. Properties in the main schema are faster to search. 

This project is the first open source implementation of the DASL
and DeltaV(linear versioning) protocols. We plan on tracking the
evolution of this protocol. 


%prep

%setup -q -n %{sourcename}
%patch0 -p1
%patch1 -p1
%patch2 -p0

# strip away annoying ^M
find . -type f|xargs file|grep 'CRLF'|cut -d: -f1|xargs perl -p -i -e 's/\r//'
find . -type f|xargs file|grep 'text'|cut -d: -f1|xargs perl -p -i -e 's/\r//'

%build
rm -f configure
autoconf

%configure \
    --with-apache=%{_prefix} \
    --with-mysql=%{_prefix}

#%%make

%{_sbindir}/apxs -I%{_includedir}/mysql -Wl,-lmysqlclient \
    -c mod_dav_repos.c repos.c props.c search.c \
    dbms.c util.c lock.c version.c dbms_mysql.c 

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

bzcat %{SOURCE2} > catacomb_HOWTO.html

# fix strange permissions
chmod 644 README TODO data.sql table.sql catacomb_HOWTO.html

install -d %{buildroot}%{_libdir}/apache-extramodules
install -d %{buildroot}%{_sysconfdir}/httpd/modules.d

install -m0755 .libs/*.so %{buildroot}%{_libdir}/apache-extramodules/
bzcat %{SOURCE1} > %{buildroot}%{_sysconfdir}/httpd/modules.d/%{mod_conf}

install -d %{buildroot}%{_var}/www/html/addon-modules
ln -s ../../../..%{_docdir}/%{name}-%{version} %{buildroot}%{_var}/www/html/addon-modules/%{name}-%{version}

%post
if [ -f %{_var}/lock/subsys/httpd ]; then
    %{_initrddir}/httpd restart 1>&2;
fi

%postun
if [ "$1" = "0" ]; then
    if [ -f %{_var}/lock/subsys/httpd ]; then
	%{_initrddir}/httpd restart 1>&2
    fi
fi

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc README TODO data.sql table.sql catacomb_HOWTO.html
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/modules.d/%{mod_conf}
%attr(0755,root,root) %{_libdir}/apache-extramodules/%{mod_so}
%{_var}/www/html/addon-modules/*

%changelog
* Sat Aug 13 2005 Oden Eriksson <oeriksson@mandriva.com> 2.0.54_0.9.0-1mdk
- added one gcc4 patch (Michael Scherer)

* Sun Mar 20 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_0.9.0-4mdk
- use the %%mkrel macro

* Mon Feb 28 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_0.9.0-3mdk
- fix %%post and %%postun to prevent double restarts
- fix bug #6574

* Wed Feb 16 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_0.9.0-2mdk
- spec file cleanups, remove the ADVX-build stuff

* Tue Feb  8 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_0.9.0-1mdk
- rebuilt for apache 2.0.53

* Tue Jan 25 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.52_0.9.0-2mdk
- rebuilt against MySQL-4.1.x system libs
- nuke redundant deps

* Tue Sep 28 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.52_0.9.0-1mdk
- built for apache 2.0.52

* Thu Sep 16 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.51_0.9.0-1mdk
- built for apache 2.0.51

* Mon Jul 12 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.50_0.9.0-1mdk
- built for apache 2.0.50
- remove redundant provides

* Fri Jun 18 2004 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.49_0.9.0-1mdk
- built for apache 2.0.49

* Wed Nov 05 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.48_0.9.0-1mdk
- built for apache 2.0.48

* Sun Sep 28 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_0.9.0-1mdk
- 0.9.0

* Thu Jul 10 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_0.8.0-1mdk
- rebuilt against latest apache2, requires and buildrequires

* Wed Jun 04 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.46_0.8.0-1mdk
- rebuilt for apache v2.0.46
- buildprereq ADVX-build >= 9.2
- fix P0

* Tue Apr 08 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.45_0.8.0-1mdk
- fix P0
- cosmetic rebuild for apache v2.0.45 

* Sun Feb 23 2003 Jean-Michel Dault <jmdault@mandrakesoft.com> 2.0.44_0.8.0-4mdk
- add requires apache2-mod_dav

* Sat Feb 22 2003 Jean-Michel Dault <jmdault@mandrakesoft.com> 2.0.44_0.8.0-3mdk
- comment out the mysql password, since the default configuration has none.
- test the package with cadaver, everything works fine.
- The TRACE errors are not errors, they are debug messages. It really took
  me a long time to find this out! =(

* Sat Feb 22 2003 Jean-Michel Dault <jmdault@mandrakesoft.com> 2.0.44_0.8.0-2mdk
- rebuild with libmysql12

* Tue Jan 21 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.44_0.8.0-1mdk
- rebuilt for apache v2.0.44
- fix P0

* Mon Jan 20 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_0.8.0-3mdk
- fix buildrequires apache2-devel >= 2.0.53-1mdk, as 
  pointed out by Olivier Thauvin

* Sat Jan 18 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_0.8.0-2mdk
- fix mod name in P0 (mod_dav_repos not libmod_dav_repos)

* Sat Jan 18 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_0.8.0-1mdk
- initial cooker contribs
